const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Pessoas_frameDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const pessoas_frame = await db.pessoas_frame.create(
      {
        id: data.id || undefined,

        atividade: data.atividade || null,
        posicao_aproximada: data.posicao_aproximada || null,
        epi_visiveis: data.epi_visiveis || null,
        foco_no_trabalho: data.foco_no_trabalho || false,

        operando_maquina: data.operando_maquina || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await pessoas_frame.setFrame(data.frame || null, {
      transaction,
    });

    await pessoas_frame.setClientes(data.clientes || null, {
      transaction,
    });

    return pessoas_frame;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const pessoas_frameData = data.map((item, index) => ({
      id: item.id || undefined,

      atividade: item.atividade || null,
      posicao_aproximada: item.posicao_aproximada || null,
      epi_visiveis: item.epi_visiveis || null,
      foco_no_trabalho: item.foco_no_trabalho || false,

      operando_maquina: item.operando_maquina || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const pessoas_frame = await db.pessoas_frame.bulkCreate(pessoas_frameData, {
      transaction,
    });

    // For each item created, replace relation files

    return pessoas_frame;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const pessoas_frame = await db.pessoas_frame.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.atividade !== undefined) updatePayload.atividade = data.atividade;

    if (data.posicao_aproximada !== undefined)
      updatePayload.posicao_aproximada = data.posicao_aproximada;

    if (data.epi_visiveis !== undefined)
      updatePayload.epi_visiveis = data.epi_visiveis;

    if (data.foco_no_trabalho !== undefined)
      updatePayload.foco_no_trabalho = data.foco_no_trabalho;

    if (data.operando_maquina !== undefined)
      updatePayload.operando_maquina = data.operando_maquina;

    updatePayload.updatedById = currentUser.id;

    await pessoas_frame.update(updatePayload, { transaction });

    if (data.frame !== undefined) {
      await pessoas_frame.setFrame(
        data.frame,

        { transaction },
      );
    }

    if (data.clientes !== undefined) {
      await pessoas_frame.setClientes(
        data.clientes,

        { transaction },
      );
    }

    return pessoas_frame;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const pessoas_frame = await db.pessoas_frame.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of pessoas_frame) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of pessoas_frame) {
        await record.destroy({ transaction });
      }
    });

    return pessoas_frame;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const pessoas_frame = await db.pessoas_frame.findByPk(id, options);

    await pessoas_frame.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await pessoas_frame.destroy({
      transaction,
    });

    return pessoas_frame;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const pessoas_frame = await db.pessoas_frame.findOne(
      { where },
      { transaction },
    );

    if (!pessoas_frame) {
      return pessoas_frame;
    }

    const output = pessoas_frame.get({ plain: true });

    output.frame = await pessoas_frame.getFrame({
      transaction,
    });

    output.clientes = await pessoas_frame.getClientes({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userClientes = (user && user.clientes?.id) || null;

    if (userClientes) {
      if (options?.currentUser?.clientesId) {
        where.clientesId = options.currentUser.clientesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.frames_imagem,
        as: 'frame',

        where: filter.frame
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.frame
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  imagem_url: {
                    [Op.or]: filter.frame
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.clientes,
        as: 'clientes',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.atividade) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('pessoas_frame', 'atividade', filter.atividade),
        };
      }

      if (filter.posicao_aproximada) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'pessoas_frame',
            'posicao_aproximada',
            filter.posicao_aproximada,
          ),
        };
      }

      if (filter.epi_visiveis) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'pessoas_frame',
            'epi_visiveis',
            filter.epi_visiveis,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.foco_no_trabalho) {
        where = {
          ...where,
          foco_no_trabalho: filter.foco_no_trabalho,
        };
      }

      if (filter.operando_maquina) {
        where = {
          ...where,
          operando_maquina: filter.operando_maquina,
        };
      }

      if (filter.clientes) {
        const listItems = filter.clientes.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          clientesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.clientesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.pessoas_frame.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('pessoas_frame', 'atividade', query),
        ],
      };
    }

    const records = await db.pessoas_frame.findAll({
      attributes: ['id', 'atividade'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['atividade', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.atividade,
    }));
  }
};
